#include <iostream>
#include <fstream>
#include "picture.h"

Picture::Picture(int x, int y): res_x(x), res_y(y)
{
    pixel.resize(x*y);
}
char to_char(Pixel p) {
    return '#';
}
void Picture::fill_with_checkerboard() {
    Pixel col(1,0,0);
    for (int y = 0; y < res_y; y++)
    for (int x = 0; x < res_x; x++) {
        pixel[y*res_x+x] = col;
    }
}

void Picture::print_to_screen()const {
    for (int y = 0; y < res_y; y++) {
        for (int x = 0; x < res_x; x++) {
            std::cout << to_char(pixel[y*res_x+x]) << ' ';
        }
        std::cout << std::endl;
    }
}

void Picture::save_as_pnm(const std::string &filename)const {
    std::ofstream file(filename);
    file << "P3" << std::endl << res_x << ' ' << res_y << std::endl << 255 << std::endl; //header
    for (int y = 0; y < res_y; y++) {
        for (int x = 0; x < res_x; x++) {
            Pixel p = pixel[y*res_x+x];
            file << int(p.x*255) << ' ';
            file << int(p.y*255) << ' ';
            file << int(p.z*255) << ' ';
        }
        file << std::endl;
    }
    file.close();
}
